// #autoload
// #name = RoboRoute (Client)
// #version = 0.3
// #date = 22 September 2002
// #author = {BEE}Shoddy[KE]
// #warrior = Shoddy
// #email = erdlftz@yahoo.com
// #web = http://www.beetribe.com/
// #author = SquirrelOfDeath
// #warrior = SquirrelOfDeath 
// #email = squirrel@teambro.org
// #web = http://sod.tribes2.org/
// #description = Record routes and have bots play them back.
// #status = Beta
// =======================================================

$RoboRouteC::Group = "";
$RoboRouteC::Route = "";
$RoboRouteC::RouteDesc = "";
$RoboRouteC::RandomRoute = 1;
$RoboRouteC::LoopCount = 0;
$RoboRouteC::LoopDelay = 5;

$RoboRouteC::InvalidChars = "/:*?\"<>|\\";

$RoboRouteC::AISkillLabel = "AI Skill: ";
$RoboRouteC::MinBBSpeedLabel = "Min. Bodyblock Speed (kph): ";

package RoboRouteClient {

    function OptionsDlg::onWake(%this) {
	if (!$RoboRouteC::Options)
	{
	    $RemapName[$RemapCount] = "Robo Spawn Bot";
	    $RemapCmd[$RemapCount]  = "RoboRoutePull";
	    $RemapCount++;
	    $RemapName[$RemapCount] = "Robo Setup Record";
	    $RemapCmd[$RemapCount]  = "RoboRouteSetupRecord";
	    $RemapCount++;
	    $RemapName[$RemapCount] = "Robo Start Record";
	    $RemapCmd[$RemapCount]  = "RoboRouteStartRecord";
	    $RemapCount++;
	    $RemapName[$RemapCount] = "Robo End Record";
	    $RemapCmd[$RemapCount]  = "RoboRouteEndRecord";
	    $RemapCount++;
	    $RemapName[$RemapCount] = "Robo Delete Bot";
	    $RemapCmd[$RemapCount]  = "RoboRouteDelBot";
	    $RemapCount++;
	    $RemapName[$RemapCount] = "Robo Options";
	    $RemapCmd[$RemapCount]  = "RoboRouteOptions";
	    $RemapCount++;
			
	    $RoboRouteC::Options = true;
	}
	parent::onWake(%this);
    }
    
    function clientCmdSetDefaultVehicleKeys(%inVehicle) {
	parent::clientCmdSetDefaultVehicleKeys(%inVehicle );
	if (%inVehicle) {
	    passengerKeys.copyBind(moveMap, RoboRoutePull);
	    passengerKeys.copyBind(moveMap, RoboRouteSetupRecord);
	    passengerKeys.copyBind(moveMap, RoboRouteStartRecord);
	    passengerKeys.copyBind(moveMap, RoboRouteEndRecord);
	    passengerKeys.copyBind(moveMap, RoboRouteDelBot);
	    passengerKeys.copyBind(moveMap, RoboRouteToggleAI);
	    passengerKeys.copyBind(moveMap, RoboRouteOptions);
	}
    }
};

function RoboRoutePull(%keydown) {
    if (%keydown) {
	$RoboRouteC::GroupListCB = "RoboRoutePullStage2();";
	commandToServer('RoboRouteGetGroupList', 3-$RoboRouteC::Team);
    }
}

function RoboRoutePullStage2() {
    // Fill in group list
    RRGroupSel.clear();
    %numgroups = getFieldCount($RoboRouteC::GroupList);
    %selected = 0;
    for (%i=0; %i<%numgroups; %i++) {
	%group = getField( $RoboRouteC::GroupList, %i );
	RRGroupSel.add( %group, %i+1 );
	if ( %group $= $RoboRouteC::Group ) {
	    %selected = %i+1;
	}
    }

    RRRouteSel.clear();

    Canvas.pushDialog( RoboRouteSpawnDlg );

    if ( %selected > 0 ) {
	RRGroupSel.setSelected( %selected );
	eval(RRGroupSel.command);
    }
}

function RoboRouteGroupSelCB() {
    %selected = RRGroupSel.getSelected();
    if ( %selected == 0 ) return;

    %group = getField( $RoboRouteC::GroupList, %selected-1 );
    $RoboRouteC::Group = %group;

    commandToServer('RoboRouteGetRouteList', 3-$RoboRouteC::Team, %group);

    Canvas.pushDialog( RoboRouteWaitDlg );

    $RoboRouteC::RouteListCB = "RoboRouteUpdateRouteList();";
}

function RoboRouteUpdateRouteList() {
    RRRouteSel.clear();
    %numroutes = getFieldCount($RoboRouteC::RouteList);
    %selected = 0;
    for (%i=0; %i<%numroutes; %i++) {
	%route = getField( $RoboRouteC::RouteList, %i );
	RRRouteSel.add( %route, %i+1 );

	if ( !$RoboRouteC::RandomRoute && %route $= $RoboRouteC::Route ) {
	    %selected = %i+1;
	}
    }

    if ( %selected > 0 ) {
	RRRouteSel.setSelected( %selected );
	RRRandomRoute.setValue(0);
    }

    Canvas.popDialog( RoboRouteWaitDlg );
}

function ClientCmdRoboRouteSetRouteList( %routeList ) {
    $RoboRouteC::RouteList = %routeList;

    %cb = $RoboRouteC::RouteListCB;
    $RoboRouteC::RouteListCB = "";

    if ( %cb !$= "" ) eval(%cb);
}

function RoboRouteCreateBot() {
    %selgroup = RRGroupSel.getSelected();
    if ( %selgroup == 0 ) {
	addMessageHudLine( "\c2No group selected." );
	return false;
    }

    %group = getField( $RoboRouteC::GroupList, %selgroup - 1 );

    if ( $RoboRouteC::RandomRoute ) {
	%route = "";
    } else {
	%selroute = RRRouteSel.getSelected();

	if ( %selroute == 0 ) {
	    addMessageHudLine( "\c2No route selected." );
	    return false;
	}

	%route = getField( $RoboRouteC::RouteList, %selroute - 1 );
	$RoboRouteC::Route = %route;
    }

    if ( $RoboRouteC::LoopCount < 0 ) {
	addMessageHudLine( "\c2Invalid loop count." );
	return false;
    }

    if ( $RoboRouteC::LoopDelay < 0 ) {
	addMessageHudLine( "\c2Invalid loop delay." );
	return false;
    }

    commandToServer( 'RoboRoutePull', 3-$RoboRouteC::Team, %group, %route,
		     $RoboRouteC::BotName, $RoboRouteC::LoopCount,
		     $RoboRouteC::LoopDelay );

    Canvas.popDialog( RoboRouteSpawnDlg );
}

function RoboRouteSetupRecord(%keydown) {
    if (%keydown) {
	$RoboRouteC::GroupListCB = "RoboRouteSetupRecordStage2();";
	commandToServer('RoboRouteGetGroupList', $RoboRouteC::Team);
    }
}

function RoboRouteSetupRecordStage2() {
    // Fill in group list
    RRRecGroupSel.clear();
    %numgroups = getFieldCount($RoboRouteC::GroupList);
    %selected = 0;
    for (%i=0; %i<%numgroups; %i++) {
	%group = getField( $RoboRouteC::GroupList, %i );
	RRRecGroupSel.add( %group, %i+1 );

	if ( %group $= $RoboRouteC::RGroup ) {
	    %selected = %i+1;
	}
    }

    if ( %selected > 0 ) {
	RRRecGroupSel.setSelected( %selected );
    }

    if ( Canvas.getContent().getName() !$= "RoboRouteRecordDlg" ) {
	Canvas.pushDialog( RoboRouteRecordDlg );
    }
}

function RoboRouteRecValidate() {

    %selected = RRRecGroupSel.getSelected();
    if ( %selected > 0 ) {
	$RoboRouteC::RGroup = getField( $RoboRouteC::GroupList, %selected - 1 );
    } else {
	$RoboRouteC::RGroup = "";
    }

    if ( %selected == 0 ) {
	addMessageHudLine( "\c2No group selected." );
	return false;
    }

    if ( $RoboRouteC::RouteDesc $= "" ) {
	addMessageHudLine( "\c2No route description given." );
	return false;
    }

    if ( !RoboRouteIsValidFilename( $RoboRouteC::RouteDesc ) ) {
	addMessageHudLine( "\c2Description contains invalid characters (" @
	    $RoboRouteC::InvalidChars @ " not allowed).");
	return false;
    }

    return true;
}

function RoboRouteStartRecord(%down) {
    if ( !%down ) return;

    if (!RoboRouteRecValidate()) {
	return;
    }

    %selected = RRRecGroupSel.getSelected();
    %group = getField( $RoboRouteC::GroupList, %selected-1 );

    commandToServer( 'RoboRouteStartRecord', %group, $RoboRouteC::RouteDesc );
}

function RoboRouteEndRecord(%keydown) {
    if (%keydown) {
	commandToServer('RoboRouteEndRecord');
    }
}

function RoboRouteDelRoute(%keydown) {
    if (%keydown) { 
	Canvas.pushDialog( RoboRouteDelRoute );
    }
}

function RoboRouteCreateNewGroup() {
    if ( $RoboRouteC::Group $= "" ) {
	addMessageHudLine( "\c2No group specified." );
	return;
    }

    if ( !RoboRouteIsValidFilename( $RoboRouteC::Group ) ) {
	addMessageHudLine( "\c2Group contains invalid characters (" @
	    $RoboRouteC::InvalidChars @ " not allowed).");
	return;
    }

    Canvas.popDialog( RoboRouteNewGroupDlg );

    commandToServer( 'RoboRouteMakeNewGroup', $RoboRouteC::Team,
		     $RoboRouteC::Group );

    $RoboRouteC::RGroup = $RoboRouteC::Group;

    RoboRouteSetupRecord( 1 );
}    

function ClientCmdRoboRouteSetGroupList( %groupList ) {
    $RoboRouteC::GroupList = %groupList;

    %cb = $RoboRouteC::GroupListCB;
    $RoboRouteC::GroupListCB = "";

    if ( %cb !$= "" ) eval(%cb);
}

function RoboRouteConnectCB( %msgType, %msgString, %clientName, %clientId, 
		             %targetId, %isAI, %isAdmin, %isSuperAdmin, 
                             %isAlias ) {
    if (StrStr(%msgString, "Welcome to Tribes") != -1) {
	$RoboRouteC::ClientID = %clientID;
    }
}

function RoboRouteJoinTeamCB( %msgType, %msgString, %clientName, %teamName, 
			      %clientId, %teamId ) {
    
    if ( %clientID == $RoboRouteC::ClientID && %teamId != 0 ) {
	$RoboRouteC::Team = %teamID;
    }
}

function RoboRouteIsValidFilename( %filename ) {
    %len = strlen( $RoboRouteC::InvalidChars );
    for (%i=0; %i<%len; %i++) {
	%chr = getSubStr( $RoboRouteC::InvalidChars, %i, 1 );
	if ( strpos( %filename, %chr ) != -1 ) {
	    return false;
	}
    }
    return true;
}

function RoboRouteDelBot( %down ) {
    if ( !%down ) return;

    $RoboRouteC::BotListCB = "RoboRouteDelBotStage2();";
    commandToServer('RoboRouteGetBotList');
}

function RoboRouteDelBotStage2() {
    RRBotSel.clear(); 
    %numbots = getFieldCount($RoboRouteC::BotList);
    for (%i=0; %i<%numbots; %i++) {
	%bot = getField( $RoboRouteC::BotList, %i );
	RRBotSel.add( %bot, %i+1 );
    }

    if ( %numbots > 0 ) {
	RRBotSel.setSelected(1);
    }
    RoboRouteUpdateBotInfo();

    if ( Canvas.getContent().getName() !$= "RoboRouteRemoveBotDlg" ) {
	Canvas.pushDialog( RoboRouteRemoveBotDlg );
    }
}

function clientCmdRoboRouteSetBotList( %BotList, %GroupList, %RouteList ) {
    $RoboRouteC::BotList = %BotList;
    $RoboRouteC::BotGroupList = %GroupList;
    $RoboRouteC::BotRouteList = %RouteList;

    %cb = $RoboRouteC::BotListCB;
    $RoboRouteC::BotListCB = "";

    if ( %cb !$= "" ) eval(%cb);
}

function RoboRouteUpdateBotInfo() {
    %selected = RRBotSel.getSelected();
    if ( %selected == 0 ) {
	RRRemoveBotGroup.setText( "Group:" );
	RRRemoveBotRoute.setText( "Route:" );
    } else {
	RRRemoveBotGroup.setText( "Group: " @ getField( $RoboRouteC::BotGroupList, %selected-1 ) );

	%route = getField( $RoboRouteC::BotRouteList, %selected-1 );
	if ( %route $= "" ) {
	    %route = "[Random]";
	}
	RRRemoveBotRoute.setText( "Route: " @ %route );
    }
}

function RoboRouteRemoveBot() {
    %selected = RRBotSel.getSelected();
    if ( %selected == 0 ) {
	addMessageHudLine( "\c2No bot selected." );
	return;
    }

    %name = getField( $RoboRouteC::BotList, %selected-1 );

    commandToServer( 'RoboRouteRemoveBot', %name );

    $RoboRouteC::BotListCB = "RoboRouteDelBotStage2();";
    commandToServer('RoboRouteGetBotList');
}

// Deprecated
function RoboRouteToggleAI(%down) {
    if (!%down) return;

    commandToServer('RoboRouteToggleAI');
}

function RoboRouteOptions( %down ) {
    if ( !%down ) return;

    $RoboRouteC::OptionsCB = "RoboRouteOptionsStage2();";
    commandToServer('RoboRouteGetOptions');
}

function RoboRouteOptionsStage2() {
    if ( Canvas.getContent().getName() !$= "RoboRouteOptionsDlg" ) {
	$RoboRouteC::OptionsActive = false;
	Canvas.pushDialog( RoboRouteOptionsDlg );
	RRAISkillText.setText( $RoboRouteC::AISkillLabel @ 
			       $RoboRouteC::AISkill );
	RROptionsAISlider.setValue( $RoboRouteC::AISkill );
	RRMinBBSpeedText.setText( $RoboRouteC::MinBBSpeedLabel @ 
				  $RoboRouteC::MinBBSpeed );
	RRMinBBSpeedSlider.setValue( $RoboRouteC::MinBBSpeed );
	$RoboRouteC::OptionsActive = true;
    }
}

function clientCmdRoboRouteSetOptions( %aiEnabled, %aiSkill, %lethalBB, 
                                       %bbSound, %minBBSpeed ) {
    $RoboRouteC::AIEnabled = %aienabled;
    $RoboRouteC::AISkill = %aiSkill;
    $RoboRouteC::LethalBB = %lethalBB;
    $RoboRouteC::BBSound = %bbSound;
    $RoboRouteC::MinBBSpeed = mFloor( %minBBSpeed + 0.5 );

    %cb = $RoboRouteC::OptionsCB;
    $RoboRouteC::OptionsCB = "";

    if ( %cb !$= "" ) eval(%cb);
}

function RoboRouteSetupGUI() {

    // New Group Dialog
    if ( isObject( RoboRouteNewGroupDlg ) ) {
	RoboRouteNewGroupDlg.delete();
    }
    new GuiControl(RoboRouteNewGroupDlg) {
	profile = "GuiDefaultProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
	
	new ShellPaneCtrl() {
	    profile = "ShellDlgPaneProfile";
	    horizSizing = "center";
	    vertSizing = "center";
	    position = "146 166";
	    extent = "348 147";
	    minExtent = "48 92";
	    visible = "1";
	    hideCursor = "0";
	    bypassHideCursor = "0";
	    helpTag = "0";
	    text = "Create New Group";
	    longTextBuffer = "0";
	    maxLength = "255";
	    noTitleBar = "0";
	    
	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "35 44";
		extent = "45 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Name:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new ShellTextEditCtrl(RRNewGroupName) {
		profile = "NewTextEditProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "86 35";
		extent = "234 39";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		longTextBuffer = "0";
		maxLength = "255";
		historySize = "0";
		password = "0";
		IRCName = "0";
		tabComplete = "0";
		deniedSound = "InputDeniedSound";
		glowOffset = "9 9";
		variable = "$RoboRouteC::Group";
	    };
	    new ShellBitmapButton(RRCreateGroupBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "26 80";
		extent = "140 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Create";
		simpleStyle = "0";
		command = "RoboRouteCreateNewGroup();";
	    };
	    new ShellBitmapButton(RRCancelNewGroupBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "178 80";
		extent = "140 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		accelerator = "escape";
		bypassHideCursor = "0";
		command = "Canvas.popDialog(RoboRouteNewGroupDlg);";
		helpTag = "0";
		text = "Cancel";
		simpleStyle = "0";
	    };
	};
    };

    // Recording Setup  Dialog
    if ( isObject( RoboRouteRecordDlg ) ) {
	RoboRouteRecordDlg.delete();
    }
    new GuiControl(RoboRouteRecordDlg)	{
	profile = "DlgBackProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
	    profile = "ShellDlgPaneProfile";
	    horizSizing = "center";
	    vertSizing = "center";
	    position = "134 149";
	    extent = "371 182";
	    minExtent = "48 92";
	    visible = "1";
	    hideCursor = "0";
	    bypassHideCursor = "0";
	    helpTag = "0";
	    text = "Route Recording Setup";
	    longTextBuffer = "0";
	    maxLength = "255";
	    noTitleBar = "0";

	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "32 46";
		extent = "45 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Group:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "32 84";
		extent = "81 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Description:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new ShellTextEditCtrl(RRRecDesc) {
		profile = "NewTextEditProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "118 74";
		extent = "224 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$RoboRouteC::RouteDesc";
		helpTag = "0";
		longTextBuffer = "0";
		maxLength = "20";
		historySize = "0";
		password = "0";
		IRCName = "0";
		tabComplete = "0";
		deniedSound = "InputDeniedSound";
		glowOffset = "9 9";
	    };
	    new ShellPopupMenu(RRRecGroupSel) {
		profile = "ShellPopupProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "119 39";
		extent = "173 36";
		minExtent = "49 36";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		longTextBuffer = "0";
		maxLength = "255";
		maxPopupHeight = "200";
		buttonBitmap = "gui/shll_pulldown";
		rolloverBarBitmap = "gui/shll_pulldownbar_rol";
		selectedBarBitmap = "gui/shll_pulldownbar_act";
		noButtonStyle = "0";
	    };
	    new ShellBitmapButton(RRRecordBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "40 120";
		extent = "140 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "if (RoboRouteRecValidate()) canvas.popDialog( RoboRouteRecordDlg );";
		helpTag = "0";
		text = "OK";
		simpleStyle = "0";
	    };
	    new ShellBitmapButton(RRRecCancelBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "191 120";
		extent = "140 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "Canvas.popDialog(RoboRouteRecordDlg);";
		accelerator = "escape";
		helpTag = "0";
		text = "Cancel";
		simpleStyle = "0";
	    };
	    new ShellBitmapButton(RRNewGroupBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "278 38";
		extent = "63 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "Canvas.pushDialog(RoboRouteNewGroupDlg);";
		helpTag = "0";
		text = "New";
		simpleStyle = "0";
	    };
	};
    };

    // Create Bot Dialog
    if ( isObject( RoboRouteSpawnDlg ) ) {
	RoboRouteSpawnDlg.delete();
    }
    new GuiControl(RoboRouteSpawnDlg) {
	profile = "GuiDefaultProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
	    profile = "ShellDlgPaneProfile";
	    horizSizing = "center";
	    vertSizing = "center";
	    position = "149 73";
	    extent = "341 323";
	    minExtent = "48 92";
	    visible = "1";
	    hideCursor = "0";
	    bypassHideCursor = "0";
	    helpTag = "0";
	    text = "Create Bot";
	    longTextBuffer = "0";
	    maxLength = "255";
	    noTitleBar = "0";

	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "37 43";
		extent = "45 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Group:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "36 76";
		extent = "43 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Route:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new ShellToggleButton(RRRandomRoute) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "110 105";
		extent = "193 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Random Route";
		longTextBuffer = "0";
		maxLength = "255";
		variable = "$RoboRouteC::RandomRoute";
	    };
	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "36 185";
		extent = "81 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Loop Count:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "36 219";
		extent = "81 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Loop Delay:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "196 187";
		extent = "95 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "(0 = no limit)";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "195 219";
		extent = "30 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "secs";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new ShellPopupMenu(RRGroupSel) {
		profile = "ShellPopupProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "106 35";
		extent = "207 36";
		minExtent = "49 36";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		longTextBuffer = "0";
		maxLength = "255";
		maxPopupHeight = "200";
		buttonBitmap = "gui/shll_pulldown";
		rolloverBarBitmap = "gui/shll_pulldownbar_rol";
		selectedBarBitmap = "gui/shll_pulldownbar_act";
		noButtonStyle = "0";
		command = "RoboRouteGroupSelCB();";
	    };
	    new ShellPopupMenu(RRRouteSel) {
		profile = "ShellPopupProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "106 67";
		extent = "207 36";
		minExtent = "49 36";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		longTextBuffer = "0";
		maxLength = "255";
		maxPopupHeight = "200";
		buttonBitmap = "gui/shll_pulldown";
		rolloverBarBitmap = "gui/shll_pulldownbar_rol";
		selectedBarBitmap = "gui/shll_pulldownbar_act";
		noButtonStyle = "0";
		command = "if ( RRRouteSel.getSelected() > 0 ) RRRandomRoute.SetValue(0);";
	    };
	    new ShellTextEditCtrl(RRLoopCount) {
		profile = "NewTextEditProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "127 177";
		extent = "64 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "1";
		longTextBuffer = "0";
		maxLength = "3";
		historySize = "0";
		password = "0";
		IRCName = "0";
		tabComplete = "0";
		deniedSound = "InputDeniedSound";
		glowOffset = "9 9";
		variable = "$RoboRouteC::LoopCount";
	    };
	    new ShellTextEditCtrl(RRLoopDelay) {
		profile = "NewTextEditProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "127 212";
		extent = "64 40";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "5";
		longTextBuffer = "0";
		maxLength = "3";
		historySize = "0";
		password = "0";
		IRCName = "0";
		tabComplete = "0";
		deniedSound = "InputDeniedSound";
		glowOffset = "9 9";
		variable = "$RoboRouteC::LoopDelay";
	    };
	    new ShellBitmapButton(RRCreateBotBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 259";
		extent = "140 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Create";
		simpleStyle = "0";
		command = "RoboRouteCreateBot();";
	    };
	    new ShellBitmapButton(RRCancelBotBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "171 259";
		extent = "140 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "Canvas.popDialog(RoboRouteSpawnDlg);";
		accelerator = "escape";
		helpTag = "0";
		text = "Cancel";
		simpleStyle = "0";
	    };
	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "36 146";
		extent = "45 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Name:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new ShellTextEditCtrl(RRBotName) {
		profile = "NewTextEditProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "106 137";
		extent = "206 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		longTextBuffer = "0";
		maxLength = "20";
		historySize = "0";
		password = "0";
		IRCName = "0";
		tabComplete = "0";
		deniedSound = "InputDeniedSound";
		glowOffset = "9 9";
		variable = "$RoboRouteC::BotName";
	    };
	};
    };

    // Delete Route Dialog
    if ( isObject( RoboRouteDelRouteDlg ) ) {
	RoboRouteDelRouteDlg.delete();
    }
    new GuiControl(RoboRouteDelRouteDlg) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
	
	new ShellPaneCtrl() {
	    profile = "ShellDlgPaneProfile";
	    horizSizing = "center";
	    vertSizing = "center";
	    position = "164 150";
	    extent = "311 179";
	    minExtent = "48 92";
	    visible = "1";
	    hideCursor = "0";
	    bypassHideCursor = "0";
	    helpTag = "0";
	    text = "Delete Route";
	    longTextBuffer = "0";
	    maxLength = "255";
	    noTitleBar = "0";
	    
	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "38 42";
		extent = "45 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Group:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new ShellPopupMenu(RRDelGroupSel) {
		profile = "ShellPopupProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "95 34";
		extent = "185 39";
		minExtent = "49 36";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		longTextBuffer = "0";
		maxLength = "255";
		maxPopupHeight = "200";
		buttonBitmap = "gui/shll_pulldown";
		rolloverBarBitmap = "gui/shll_pulldownbar_rol";
		selectedBarBitmap = "gui/shll_pulldownbar_act";
		noButtonStyle = "0";
	    };
	    new ShellPopupMenu(RRDelRouteSel) {
		profile = "ShellPopupProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "96 69";
		extent = "184 36";
		minExtent = "49 36";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		longTextBuffer = "0";
		maxLength = "255";
		maxPopupHeight = "200";
		buttonBitmap = "gui/shll_pulldown";
		rolloverBarBitmap = "gui/shll_pulldownbar_rol";
		selectedBarBitmap = "gui/shll_pulldownbar_act";
		noButtonStyle = "0";
	    };
	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "38 76";
		extent = "43 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Route:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new ShellBitmapButton(RRDelRouteBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "28 113";
		extent = "124 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Delete";
		simpleStyle = "0";
	    };
	    new ShellBitmapButton(RRDelCancelBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "155 113";
		extent = "124 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		accelerator = "escape";
		command = "Canvas.popDialog(RoboRouteDelRouteDlg);";
		text = "Cancel";
		simpleStyle = "0";
	    };
	};
    };

    if ( isObject( RoboRouteWaitDlg ) ) {
	RoboRouteWaitDlg.delete();
    }
    new GuiControl(RoboRouteWaitDlg) {
	profile = "GuiDefaultProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
	    profile = "ShellDlgPaneProfile";
	    horizSizing = "center";
	    vertSizing = "center";
	    position = "163 196";
	    extent = "317 104";
	    minExtent = "48 92";
	    visible = "1";
	    hideCursor = "0";
	    bypassHideCursor = "0";
	    helpTag = "0";
	    text = "Please Wait...";
	    longTextBuffer = "0";
	    maxLength = "255";
	    noTitleBar = "0";

	    new GuiTextCtrl() {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "83 45";
		extent = "149 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Refreshing route list...";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	};
    };

    // Remove Bot Dialog
    if ( isObject( RoboRouteRemoveBotDlg ) ) {
	RoboRouteRemoveBotDlg.delete();
    }
    new GuiControl(RoboRouteRemoveBotDlg) {
	profile = "GuiDefaultProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
	
	new ShellPaneCtrl() {
	    profile = "ShellDlgPaneProfile";
	    horizSizing = "center";
	    vertSizing = "center";
	    position = "175 146";
	    extent = "298 206";
	    minExtent = "48 92";
	    visible = "1";
	    hideCursor = "0";
	    bypassHideCursor = "0";
	    helpTag = "0";
	    text = "Remove Bot";
	    longTextBuffer = "0";
	    maxLength = "255";
	    noTitleBar = "0";
	    
	    new ShellPopupMenu(RRBotSel) {
		profile = "ShellPopupProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "31 46";
		extent = "170 42";
		minExtent = "49 36";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		longTextBuffer = "0";
		maxLength = "255";
		maxPopupHeight = "200";
		buttonBitmap = "gui/shll_pulldown";
		rolloverBarBitmap = "gui/shll_pulldownbar_rol";
		selectedBarBitmap = "gui/shll_pulldownbar_act";
		noButtonStyle = "0";
		command = "RoboRouteUpdateBotInfo();";
	    };
	    new ShellBitmapButton(RRRemoveBotBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "193 46";
		extent = "74 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Remove";
		simpleStyle = "0";
		command = "RoboRouteRemoveBot();";
	    };
	    new GuiTextCtrl(RRRemoveBotGroup) {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "39 87";
		extent = "216 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Group:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new GuiTextCtrl(RRRemoveBotRoute) {
		profile = "ShellMediumTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "40 113";
		extent = "217 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Route:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new ShellBitmapButton() {
		profile = "ShellButtonProfile";
		horizSizing = "center";
		vertSizing = "bottom";
		position = "79 145";
		extent = "140 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "Canvas.popDialog(RoboRouteRemoveBotDlg);";
		accelerator = "escape";
		helpTag = "0";
		text = "Close";
		simpleStyle = "0";
	    };
	};
    };

    // Options Dialog
    if ( isObject( RoboRouteOptionsDlg ) ) {
	RoboRouteOptionsDlg.delete();
    }
    new GuiControl(RoboRouteOptionsDlg) {
	profile = "GuiDefaultProfile";
	horizSizing = "width";
	vertSizing = "height";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
	    profile = "ShellDlgPaneProfile";
	    horizSizing = "center";
	    vertSizing = "center";
	    position = "171 61";
	    extent = "297 305";
	    minExtent = "48 92";
	    visible = "1";
	    hideCursor = "0";
	    bypassHideCursor = "0";
	    helpTag = "0";
	    text = "RoboRoute Options";
	    longTextBuffer = "0";
	    maxLength = "255";
	    noTitleBar = "0";

	    new ShellBitmapButton(RROptionsOKBtn) {
		profile = "ShellButtonProfile";
		horizSizing = "center";
		vertSizing = "bottom";
		position = "78 238";
		extent = "140 38";
		minExtent = "32 38";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		command = "Canvas.popDialog(RoboRouteOptionsDlg);";
		accelerator = "escape";
		helpTag = "0";
		text = "OK";
		simpleStyle = "0";
	    };
	    new ShellToggleButton(RROptionsAI) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "50 43";
		extent = "185 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$RoboRouteC::AIEnabled";
		command = "if ( $RoboRouteC::OptionsActive ) { commandToServer( \'RoboRouteSetOption\', \"AIEnabled\", $RoboRouteC::AIEnabled ); }";
		helpTag = "0";
		text = "Bot AI Enabled";
		longTextBuffer = "0";
		maxLength = "255";
		groupNum = "-1";
	    };
	    new ShellToggleButton(RROptionsLethalBB) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "50 129";
		extent = "185 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$RoboRouteC::LethalBB";
		command = "if ( $RoboRouteC::OptionsActive ) { commandToServer( \'RoboRouteSetOption\', \"LethalBB\", $RoboRouteC::LethalBB ); }";
		helpTag = "0";
		text = "Lethal Body Blocks";
		longTextBuffer = "0";
		maxLength = "255";
		groupNum = "-1";
	    };
	    new ShellToggleButton(RROptionsBBSound) {
		profile = "ShellRadioProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "50 155";
		extent = "185 30";
		minExtent = "26 27";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "$RoboRouteC::BBSound";
		command = "if ( $RoboRouteC::OptionsActive ) { commandToServer( \'RoboRouteSetOption\', \"BBSound\", $RoboRouteC::BBSound ); }";
		helpTag = "0";
		text = "Body Block Sound";
		longTextBuffer = "0";
		maxLength = "255";
		groupNum = "-1";
	    };
	    new ShellSliderCtrl(RROptionsAISlider) {
		profile = "ShellSliderProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "55 89";
		extent = "179 24";
		minExtent = "12 24";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "value";
		command = "if ( $RoboRouteC::OptionsActive ) { RoboRouteAISliderChanged(1); }";
		altcommand = "if ( $RoboRouteC::OptionsActive ) { RoboRouteAISliderChanged(0); }";
		helpTag = "0";
		range = "0.000000 1.000000";
		ticks = "1000";
		value = "0.5";
		usePlusMinus = "1";
	    };
	    new GuiTextCtrl(RRAISkillText) {
		profile = "ShellTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "55 71";
		extent = "39 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "AI Skill:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	    new ShellSliderCtrl(RRMinBBSpeedSlider) {
		profile = "ShellSliderProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "55 203";
		extent = "179 24";
		minExtent = "12 24";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		variable = "value";
		helpTag = "0";
		range = "0.000000 200.000000";
		ticks = "1000";
		value = "0.5";
		usePlusMinus = "1";
		variable = "$RoboRouteC::MinBBSpeed";
		command = "if ( $RoboRouteC::OptionsActive ) { RoboRouteBBSliderChanged(1); }";
		altcommand = "if ( $RoboRouteC::OptionsActive ) { RoboRouteBBSliderChanged(0); }";
	    };
	    new GuiTextCtrl(RRMinBBSpeedText) {
		profile = "ShellTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "55 185";
		extent = "120 22";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Min. Body Block Speed:";
		longTextBuffer = "0";
		maxLength = "255";
	    };
	};
    };
}

function RoboRouteAISliderChanged(%final) {
    %val = RROptionsAISlider.getValue();
    %val = ( mFloor( %val * 100 + 0.5 )/100.0 );

    RRAISkillText.setText( $RoboRouteC::AISkillLabel @ %val );

    if (%final) {
	commandToServer( 'RoboRouteSetOption', "AISkill", %val );
    }
}

function RoboRouteBBSliderChanged(%final) {
    %val = RRMinBBSpeedSlider.getValue();
    %val = mFloor( %val + 0.5 );

    RRMinBBSpeedText.setText( $RoboRouteC::MinBBSpeedLabel @ %val );

    if ( %final ) {
	commandToServer( 'RoboRouteSetOption', "MinBBSpeed", %val );
    }
}

addMessageCallback('MsgClientJoinTeam', RoboRouteJoinTeamCB);
addMessageCallback('MsgClientJoin', RoboRouteConnectCB);

activatePackage(RoboRouteClient);
RoboRouteSetupGUI();

function RoboRouteReload() {
    exec("scripts/autoexec/RoboRouteServer.cs");
    exec("scripts/autoexec/RoboRouteClient.cs");
}
